open Folds_recs
open Trie
open Church
open OUnit2

let fold_tests = "fold tests" >:::
  [
    "tail_recursive_map_test_01" >::
      (fun _ ->
        assert_equal
        (tail_recursive_map (fun x -> x+1) [1; 2; 3])
        [2; 3; 4]
      );
    "mapi_test_01" >::
      (fun _ ->
        assert_equal
        (mapi (fun i elt -> if (i mod 2 = 0) then elt+1 else elt+2) [1; 2; 3; 4; 5])
        [2; 4; 4; 6; 6]
      );
      "count_vote_test_01" >::
      (fun _ ->
        assert_equal
        (count_vote [true; true; true; false; true; false])
        (4,2)
      );
    "partition_test_01" >::
      (fun _ ->
        assert_equal
        (partition (fun x -> x > 3) [1; 3; 4; 2; 5; 2; 0; 8])
        ([4; 5; 8], [1; 3; 2; 2; 0])
      );
    "scan_left_test_01" >::
      (fun _ ->
        assert_equal
        (scan_left (^) "swag" ["zar"; "doz"])
        ["swag"; "swagzar"; "swagzardoz"]
      );
    "scan_right_test_01" >::
      (fun _ ->
        assert_equal
        (scan_right (+) [1; 2; 3] 0)
        [0; 3; 5; 6]
      );
    "scan_right_test_01" >::
      (fun _ ->
        assert_equal
        (scan_right (^) ["zar"; "doz"] "swag")
        ["swag"; "dozswag"; "zardozswag"]
      );
  ]

let rec_tests  = "rec_tests" >:::
  [
    "sep_list_test_01" >::
      (fun _ ->
        assert_equal
        (sep_list [1; 1; 1; 2; 3; 3; 1; 1; 5; 5; 5; 5])
        [[1; 1; 1; ]; [2]; [3; 3]; [1; 1]; [5; 5; 5; 5]]
      );
    "slice_list_test_01" >::
      (fun _ ->
        assert_equal
        (slice_list ["a"; "b"; "c"; "d"; "e"; "f"; "g"] 1 4)
        ["b"; "c"; "d"; "e"]
      );
      "rotate_list_test_01" >::
      (fun _ ->
        assert_equal
        (rotate_list ["a"; "b"; "c"; "d"; "e"; "f"; "g"] 2)
        ["c"; "d"; "e"; "f"; "g"; "a"; "b"]
      );
      "rotate_list_test_02" >::
      (fun _ ->
        assert_equal
        (rotate_list ["a"; "b"; "c"; "d"; "e"; "f"; "g"] (-2))
        ["f"; "g"; "a"; "b"; "c"; "d"; "e"]
      );
  ]

let _ = run_test_tt_main fold_tests
let _ = run_test_tt_main rec_tests
